package cn.ibizlab.businesscentral.core.odoo_account.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.aop.framework.AopContext;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_bank_statement_import_journal_creation;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_bank_statement_import_journal_creationSearchContext;
import cn.ibizlab.businesscentral.core.odoo_account.service.IAccount_bank_statement_import_journal_creationService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.util.helper.EBSServiceImpl;
import cn.ibizlab.businesscentral.core.odoo_account.mapper.Account_bank_statement_import_journal_creationMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;

import org.springframework.util.StringUtils;

/**
 * 实体[在银行对账单导入创建日记账] 服务对象接口实现
 */
@Slf4j
@Service("Account_bank_statement_import_journal_creationServiceImpl")
public class Account_bank_statement_import_journal_creationServiceImpl extends EBSServiceImpl<Account_bank_statement_import_journal_creationMapper, Account_bank_statement_import_journal_creation> implements IAccount_bank_statement_import_journal_creationService {

    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_account.service.IAccount_journalService accountJournalService;
    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_base.service.IRes_usersService resUsersService;

    protected int batchSize = 500;

    public String getIrModel(){
        return "account.bank.statement.import.journal.creation" ;
    }

    private boolean messageinfo = false ;

    public void setMessageInfo(boolean messageinfo){
        this.messageinfo = messageinfo ;
    }

    @Override
    @Transactional
    public boolean create(Account_bank_statement_import_journal_creation et) {
        boolean mail_create_nosubscribe = et.get("mail_create_nosubscribe") != null;
        boolean mail_create_nolog = et.get("mail_create_nolog") != null;
        boolean mail_notrack = et.get("mail_notrack") != null;
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy((AopContext.currentProxy() != null ? (IAccount_bank_statement_import_journal_creationService)AopContext.currentProxy() : this).get(et.getId()),et);

        if (messageinfo && !mail_create_nosubscribe) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_followersExService.class).add_default_followers(this,et);
        }

        if (messageinfo && !mail_create_nolog) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_messageExService.class).add_default_create_message(this,et);
        }

        if (messageinfo && !mail_notrack) {

        }
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<Account_bank_statement_import_journal_creation> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(Account_bank_statement_import_journal_creation et) {
        Account_bank_statement_import_journal_creation old = new Account_bank_statement_import_journal_creation() ;
        CachedBeanCopier.copy((AopContext.currentProxy() != null ? (IAccount_bank_statement_import_journal_creationService)AopContext.currentProxy() : this).get(et.getId()), old);
        boolean mail_notrack = et.get("mail_notrack") != null;
        fillParentData(et);
         if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("id",et.getId())))
            return false;
        CachedBeanCopier.copy((AopContext.currentProxy() != null ? (IAccount_bank_statement_import_journal_creationService)AopContext.currentProxy() : this).get(et.getId()),et);
        if (messageinfo && !mail_notrack) {
            cn.ibizlab.businesscentral.util.security.SpringContextHolder.getBean(cn.ibizlab.businesscentral.core.extensions.service.Mail_tracking_valueExService.class).message_track(this,old,et);
        }
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<Account_bank_statement_import_journal_creation> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(Long key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<Long> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public Account_bank_statement_import_journal_creation get(Long key) {
        Account_bank_statement_import_journal_creation et = getById(key);
        if(et==null){
            et=new Account_bank_statement_import_journal_creation();
            et.setId(key);
        }
        else{
        }
        return et;
    }

    @Override
    public Account_bank_statement_import_journal_creation getDraft(Account_bank_statement_import_journal_creation et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(Account_bank_statement_import_journal_creation et) {
        return (!ObjectUtils.isEmpty(et.getId()))&&(!Objects.isNull(this.getById(et.getId())));
    }
    @Override
    @Transactional
    public boolean save(Account_bank_statement_import_journal_creation et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(Account_bank_statement_import_journal_creation et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<Account_bank_statement_import_journal_creation> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<Account_bank_statement_import_journal_creation> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<Account_bank_statement_import_journal_creation> selectByJournalId(Long id) {
        return baseMapper.selectByJournalId(id);
    }
    @Override
    public void removeByJournalId(Collection<Long> ids) {
        this.remove(new QueryWrapper<Account_bank_statement_import_journal_creation>().in("journal_id",ids));
    }

    @Override
    public void removeByJournalId(Long id) {
        this.remove(new QueryWrapper<Account_bank_statement_import_journal_creation>().eq("journal_id",id));
    }

	@Override
    public List<Account_bank_statement_import_journal_creation> selectByCreateUid(Long id) {
        return baseMapper.selectByCreateUid(id);
    }
    @Override
    public void removeByCreateUid(Long id) {
        this.remove(new QueryWrapper<Account_bank_statement_import_journal_creation>().eq("create_uid",id));
    }

	@Override
    public List<Account_bank_statement_import_journal_creation> selectByWriteUid(Long id) {
        return baseMapper.selectByWriteUid(id);
    }
    @Override
    public void removeByWriteUid(Long id) {
        this.remove(new QueryWrapper<Account_bank_statement_import_journal_creation>().eq("write_uid",id));
    }


    /**
     * 查询集合 数据集
     */
    @Override
    public Page<Account_bank_statement_import_journal_creation> searchDefault(Account_bank_statement_import_journal_creationSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<Account_bank_statement_import_journal_creation> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<Account_bank_statement_import_journal_creation>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(Account_bank_statement_import_journal_creation et){
        //实体关系[DER1N_ACCOUNT_BANK_STATEMENT_IMPORT_JOURNAL_CREATION__ACCOUNT_JOURNAL__JOURNAL_ID]
        if(!ObjectUtils.isEmpty(et.getJournalId())){
            cn.ibizlab.businesscentral.core.odoo_account.domain.Account_journal odooJournal=et.getOdooJournal();
            if(ObjectUtils.isEmpty(odooJournal)){
                cn.ibizlab.businesscentral.core.odoo_account.domain.Account_journal majorEntity=accountJournalService.get(et.getJournalId());
                et.setOdooJournal(majorEntity);
                odooJournal=majorEntity;
            }
            et.setAliasDomain(odooJournal.getAliasDomain());
            et.setRefundSequenceId(odooJournal.getRefundSequenceId());
            et.setSequence(odooJournal.getSequence());
            et.setCurrencyId(odooJournal.getCurrencyId());
            et.setBankId(odooJournal.getBankId());
            et.setLossAccountId(odooJournal.getLossAccountId());
            et.setDefaultCreditAccountId(odooJournal.getDefaultCreditAccountId());
            et.setRefundSequence(odooJournal.getRefundSequence());
            et.setAtLeastOneOutbound(odooJournal.getAtLeastOneOutbound());
            et.setProfitAccountId(odooJournal.getProfitAccountId());
            et.setUpdatePosted(odooJournal.getUpdatePosted());
            et.setRefundSequenceNumberNext(odooJournal.getRefundSequenceNumberNext());
            et.setAliasId(odooJournal.getAliasId());
            et.setCode(odooJournal.getCode());
            et.setGroupInvoiceLines(odooJournal.getGroupInvoiceLines());
            et.setAliasName(odooJournal.getAliasName());
            et.setBankAccountId(odooJournal.getBankAccountId());
            et.setColor(odooJournal.getColor());
            et.setAtLeastOneInbound(odooJournal.getAtLeastOneInbound());
            et.setBankAccNumber(odooJournal.getBankAccNumber());
            et.setSequenceNumberNext(odooJournal.getSequenceNumberNext());
            et.setCompanyPartnerId(odooJournal.getCompanyPartnerId());
            et.setCompanyId(odooJournal.getCompanyId());
            et.setDefaultDebitAccountId(odooJournal.getDefaultDebitAccountId());
            et.setActive(odooJournal.getActive());
            et.setBankStatementsSource(odooJournal.getBankStatementsSource());
            et.setKanbanDashboard(odooJournal.getKanbanDashboard());
            et.setKanbanDashboardGraph(odooJournal.getKanbanDashboardGraph());
            et.setShowOnDashboard(odooJournal.getShowOnDashboard());
            et.setPostAtBankRec(odooJournal.getPostAtBankRec());
            et.setBelongsToCompany(odooJournal.getBelongsToCompany());
            et.setName(odooJournal.getName());
            et.setType(odooJournal.getType());
            et.setSequenceId(odooJournal.getSequenceId());
        }
        //实体关系[DER1N_ACCOUNT_BANK_STATEMENT_IMPORT_JOURNAL_CREATION__RES_USERS__CREATE_UID]
        if(!ObjectUtils.isEmpty(et.getCreateUid())){
            cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users odooCreate=et.getOdooCreate();
            if(ObjectUtils.isEmpty(odooCreate)){
                cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users majorEntity=resUsersService.get(et.getCreateUid());
                et.setOdooCreate(majorEntity);
                odooCreate=majorEntity;
            }
            et.setCreateUidText(odooCreate.getName());
        }
        //实体关系[DER1N_ACCOUNT_BANK_STATEMENT_IMPORT_JOURNAL_CREATION__RES_USERS__WRITE_UID]
        if(!ObjectUtils.isEmpty(et.getWriteUid())){
            cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users odooWrite=et.getOdooWrite();
            if(ObjectUtils.isEmpty(odooWrite)){
                cn.ibizlab.businesscentral.core.odoo_base.domain.Res_users majorEntity=resUsersService.get(et.getWriteUid());
                et.setOdooWrite(majorEntity);
                odooWrite=majorEntity;
            }
            et.setWriteUidText(odooWrite.getName());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<Account_bank_statement_import_journal_creation> getAccountBankStatementImportJournalCreationByIds(List<Long> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<Account_bank_statement_import_journal_creation> getAccountBankStatementImportJournalCreationByEntities(List<Account_bank_statement_import_journal_creation> entities) {
        List ids =new ArrayList();
        for(Account_bank_statement_import_journal_creation entity : entities){
            Serializable id=entity.getId();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }



}



